(function() {

    "use strict";

    // 在庫アプリ操作
    var syohinDao = {};
    syohinDao.APP_ID = 16;

    // 新規レコードの保存イベント
    kintone.events.on('app.record.create.submit', function(event) {
        // 制御項目の非表示
        // 入出庫レコード情報取得
        var record = event.record;

        // 検索パラメータ
        var params = {
            // 商品アプリ番号
            "app": syohinDao.APP_ID,
            // 検索条件
            "query": '商品番号 ="' + record['商品番号']['value'] + '"',
            // 取得項目
            "fields": ['$id', '$revision', '帳簿在庫数']
        };
        return kintone.api('/k/v1/records', 'GET', params).then(function(resp) {
            var syohinRecord = resp['records'][0];

            if (syohinRecord.length !== 0) {
                var updQuantity = 0;
                // 入庫、等の場合
                if (record['入庫数']['value']) {
                    updQuantity = Number(syohinRecord['帳簿在庫数']['value']) + Number(record['入庫数']['value']);
                }
                // 出庫、等の場合
                if (record['出庫数']['value']) {
                    updQuantity = Number(syohinRecord['帳簿在庫数']['value']) - Number(record['出庫数']['value']);
                }
                if (updQuantity < 0) {
                    // 更新後の在庫数がマイナスになる場合はエラーにして中断
                    alert("在庫が足りません。");
                    record['出庫数']['error'] = "在庫が足りません。";
                    event['error'] = "在庫が足りません。";
                    return event;
                }

                // 更新パラメータ
                var params2 = {
                    // 商品アプリ番号
                    "app": syohinDao.APP_ID,
                    // レコード番号
                    "id": syohinRecord['$id']['value'],
                    // レビジョン
                    "revision": syohinRecord['$revision']['value'],
                    // 登録データ
                    "record": {
                        "帳簿在庫数": {
                            "value": updQuantity
                        }
                    }
                };
                // 商品レコードを更新
                return kintone.api(kintone.api.url('/k/v1/record', true), 'PUT', params2).then(function(resp2) {
                    alert("商品レコードを更新しました。");
                }, function(resp2) {
                    alert("商品レコードを取得できません。");
                });
            }
        }, function(resp) {
            alert("商品レコードを取得できません。");
            event['error'] = "商品レコードを取得できません。";
            return event;
        });
    });
})();
